using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;


public partial class StoredProcedures
{
    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void isp_DatabaseGrowth(string srvName)
    {
        string sql = @"
            select 
                DATABASE_NAME = db_name(s_mf.database_id), 
                DATABASE_SIZE = convert(bigint, convert(bigint, sum(s_mf.size))*8), 
                REMARKS = convert(varchar(254),null) 
            from sys.master_files s_mf 
            where 
                s_mf.state = 0 and 
                has_dbaccess(db_name(s_mf.database_id)) = 1 
            group by s_mf.database_id 
            order by 1";

        SqlConnection cnDbGrowth = new SqlConnection();
        SqlConnection cnSql = new SqlConnection();
        //SqlCommand cmd = new SqlCommand("sp_databases", cnSql);
        SqlCommand cmd = new SqlCommand(sql, cnSql);
        SqlDataAdapter adapter = new SqlDataAdapter(cmd);
        DataTable dtSpaceUsed = new DataTable();

        cnDbGrowth.ConnectionString = "Context Connection=true";
        cnSql.ConnectionString = "Data Source=" + srvName + "; Initial Catalog=master; Integrated Security=True;";

        cmd.CommandType = CommandType.Text;

        cnSql.Open();
        adapter.Fill(dtSpaceUsed);
        cnSql.Close();

        cmd.Connection = cnDbGrowth;
        cmd.CommandType = CommandType.Text;
        cmd.CommandText = "INSERT INTO dbo.DatabaseGrowth (ServerName, DatabaseName, DatabaseSize) VALUES(@srvName, @dbName, @dbSize)";
        cmd.Parameters.Add("@srvName", SqlDbType.VarChar).Value = srvName;
        cmd.Parameters.Add("@dbName", SqlDbType.VarChar);
        cmd.Parameters.Add("@dbSize", SqlDbType.BigInt);

        cnDbGrowth.Open();
        foreach (DataRow row in dtSpaceUsed.Rows)
        {
            foreach (DataColumn col in dtSpaceUsed.Columns)
            {
                if (col.Ordinal == 0)
                    cmd.Parameters["@dbName"].Value = row[col].ToString();

                if (col.Ordinal == 1)
                    cmd.Parameters["@dbSize"].Value = row[col].ToString();
            }
            cmd.ExecuteNonQuery();
        }
        cnDbGrowth.Close();
    }
}
