USE master
GO

EXEC sp_configure 'show advanced options', 1
RECONFIGURE
EXEC sp_configure 'clr enabled', 1
RECONFIGURE

ALTER DATABASE Admin SET TRUSTWORTHY ON
GO

USE Admin
GO

CREATE TABLE DatabaseGrowth
(
	ServerName varchar(256) NOT NULL,
	DatabaseName varchar(256) NOT NULL,
	DatabaseSize int NOT NULL,
	CreateDate datetime NOT NULL
)
GO

ALTER TABLE dbo.DatabaseGrowth ADD CONSTRAINT
	DF_DatabaseGrowth_CreateDate DEFAULT GETDATE() FOR CreateDate
GO

ALTER TABLE dbo.DatabaseGrowth ADD CONSTRAINT
	PK_DatabaseGrowth PRIMARY KEY CLUSTERED 
	(
	ServerName, DatabaseName, CreateDate
	) WITH( STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO

CREATE ASSEMBLY [DatabaseGrowth]
FROM 'F:\Backup\DatabaseGrowth.dll'
WITH PERMISSION_SET = EXTERNAL_ACCESS
GO

CREATE PROCEDURE [dbo].[isp_DatabaseGrowth] @srvName [nvarchar](4000)
WITH EXECUTE AS CALLER
AS
EXTERNAL NAME [DatabaseGrowth].[StoredProcedures].[isp_DatabaseGrowth]
GO
